using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using EVCB_OCPP.Packet.Messages.SubTypes;
using EVCB_OCPP.Packet.Features;

namespace EVCB_OCPP.Packet.Messages.FirmwareManagement
{
    public class DiagnosticsStatusNotificationRequest : IRequest
    {
        public DiagnosticsStatusNotificationRequest()
        {
            Action = Actions.DiagnosticsStatusNotification.ToString();
        }

        [JsonIgnore]
        public string Action { set; get; }

        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public DiagnosticsStatus status { set; get; }

        public bool TransactionRelated()
        {
            return false;
        }

        public bool Validate()
        {
            return Validator.TryValidateObject(this, new ValidationContext(this), null, true);
        }
    }
}
